<?xml version="1.0" encoding="UTF-8"?>

<cfsSimulation xmlns="http://www.cfs++.org/simulation">
  <documentation>
    <title>embedded python as optimizer (here ocm)</title>
    <authors>
      <author>Fabian Wein</author>
     </authors>
    <date>2020-10-19</date>
    <keywords>
      <keyword>optimization</keyword>
    </keywords>
    <references>none</references>
    <isVerified>yes</isVerified>
    <description>We use an embedded python interpreter, triggered by USE_EMBEDDED_PYTHON to run an external python file as optimizer.
    </description>
  </documentation>
  <fileFormats>
    <output>
        <hdf5 />
      <info/>
    </output>
    <materialData file="mat.xml" format="xml" />
  </fileFormats>

  <domain geometryType="plane">
    <regionList>
      <region material="99lines" name="mech" />
    </regionList>
    <nodeList>
      <nodes name="load">
        <coord x="1" y="0" />
      </nodes>
    </nodeList>
  </domain>

  <sequenceStep index="1">
    <analysis>
      <static/>
    </analysis>

    <pdeList>
      <mechanic subType="planeStress">
        <regionList>
          <region name="mech" />
        </regionList>

        <bcsAndLoads>
           <fix name="west"> 
              <comp dof="x"/> 
              <comp dof="y"/> 
           </fix>
           <force name="load">
             <comp dof="y" value="-1"/>
           </force>
        </bcsAndLoads>

        <storeResults>
          <nodeResult type="mechDisplacement">
            <allRegions/>
          </nodeResult>
          <elemResult type="mechPseudoDensity">
            <allRegions/>
          </elemResult>
          <elemResult type="physicalPseudoDensity">
            <allRegions/>
          </elemResult>
        </storeResults>
      </mechanic>
    </pdeList>

   <linearSystems>
      <system>
        <solverList>
          <directLDL/>
        </solverList>
      </system>
    </linearSystems> 
  </sequenceStep>

    
  <optimization>
    <costFunction type="compliance" task="minimize" >
      <stopping queue="999" value="0.001" type="designChange"/>
    </costFunction>

    <constraint type="volume" value=".5" bound="upperBound" linear="true" mode="constraint"  />

    <optimizer type="python" maxIterations="10">
      <python file="ocm.py">
        <option key="move" value=".2"/>
        <option key="damp" value=".5"/>
      </python>
    </optimizer>

    <ersatzMaterial region="mech" material="mechanic" method="simp" >
      <filters>
        <filter neighborhood="maxEdge" value="1.3" type="density" />
      </filters>

      <design name="density" initial=".5" physical_lower="1e-9" upper="1.0" />

      <transferFunction type="simp" application="mech" param="3"/>
      <export save="all" write="iteration"/>
    </ersatzMaterial>
    <commit mode="forward" stride="1"/>
  </optimization>
</cfsSimulation>


